#include <stdbool.h>
#include "nrf_pwm.h"



#include <stdint.h>
#include <string.h>
#include "spi_master.h"
#include "nrf_gpiote.h"
#include "nordic_common.h"
#include "nrf.h"
#include "app_error.h"
#include "nrf_gpio.h"
#include "nrf51_bitfields.h"
#include "ble.h"
#include "ble_hci.h"
#include "ble_srv_common.h"
#include "ble_advdata.h"
#include "ble_conn_params.h"
#include "boards.h"
#include "app_scheduler.h"
#include "softdevice_handler.h"
#include "app_timer.h"
#include "ble_error_log.h"
#include "app_gpiote.h"
#include "app_button.h"
#include "ble_debug_assert_handler.h"
#include "pstorage.h"
#include "ble_lbs.h"
 #include "nrf_delay.h"
 #include "simple_uart.h"
 #include "boards.h"




volatile bool   transmission_completed = false;


#define SPI_MASTER_0_ENABLE /**< Enable SPI_MASTER_0 */

void spi_master_event_handler(spi_master_evt_t spi_master_evt)
{
    switch (spi_master_evt.evt_type)
    {
        case SPI_MASTER_EVT_TRANSFER_COMPLETED:
            //Data transmission is ended successful. 'rx_buffer' has data received from SPI slave.
            
            transmission_completed = true;
            break;
            
        default:
            //No implementation needed.
            break;
    }
}


void spi_master_init(void)
{
    //Structure for SPI master configuration, initialized by default values.
    spi_master_config_t spi_config = SPI_MASTER_INIT_DEFAULT;
    
    //Configure SPI master.
    spi_config.SPI_Pin_SCK  = SPIM0_SCK_PIN;
    spi_config.SPI_Pin_MISO = SPIM0_MISO_PIN;
    spi_config.SPI_Pin_MOSI = SPIM0_MOSI_PIN;
    spi_config.SPI_Pin_SS   = SPIM0_SS_PIN;
    
    //Initialize SPI master.
    uint32_t err_code = spi_master_open(SPI_MASTER_0, &spi_config);
    if (err_code != NRF_SUCCESS)
    {
        //Module initialization failed. Take recovery action.
    }
    
    //Register SPI master event handler.
    spi_master_evt_handler_reg(SPI_MASTER_0, spi_master_event_handler);
}



//call this routine where spi communication is required.
void send_data(){
uint16_t        buf_len = TX_RX_MSG_LENGTH;
uint8_t         rx_buffer[TX_RX_MSG_LENGTH];    //Receive buffer to get data from SPI slave.
uint8_t         tx_buffer[TX_RX_MSG_LENGTH];    //Transmit buffer to send data from SPI master with sample data.
volatile bool   transmission_completed = false;
//Fill transmit buffer with sample data, numbers from (0 - (buf_len - 1)).
int index;
for (index = 0; index < TX_RX_MSG_LENGTH; index++)
{
    tx_buffer[index] = index;
}
uint32_t err_code = spi_master_send_recv(SPI_MASTER_0, tx_buffer, buf_len, rx_buffer, buf_len);
if (err_code != NRF_SUCCESS)
{
    //Data transmission failed.
}
//Data transmission is ended successful when the SPI_MASTER_EVT_TRANSFER_COMPLETED is received by the spi_master_event_handler(spi_master_evt_t spi_master_evt).

}